#ifndef _BATCH_QUEUE_COMMON_COMM_H_
#define _BATCH_QUEUE_COMMON_COMM_H_ 1

#include <stdint.h>
#include <unistd.h>

/* Non standard include */
#include <commtech.h>

#ifndef BUF_SIZE
#define BUF_SIZE (32 * CACHE_LINE_SIZE)
#endif

struct channel
{
	/* buf must be the first field to allow the buf_mask test */
	void * volatile buf[2][BUF_SIZE / sizeof(void *)] __attribute__ ((aligned (CACHE_LINE_SIZE)));
	int unused[20] __attribute__ ((aligned (CACHE_LINE_SIZE)));
	volatile unsigned int  state:1 __attribute__ ((aligned (CACHE_LINE_SIZE)));

	/* accesses to buf[0] and state */
	struct channel *mapping1 __attribute__ ((aligned (CACHE_LINE_SIZE)));
	/* accesses to buf[1] */
	struct channel *mapping2;
	void * volatile *buf_end1;
	void * volatile *buf_end2;

	void * volatile *sender_ptr __attribute__ ((aligned (CACHE_LINE_SIZE)));
	void * volatile *sender_ptr_end;
	void * volatile *receiver_ptr __attribute__ ((aligned (CACHE_LINE_SIZE)));
};


__BEGIN_DECLS

static inline void send(struct channel *channel, void **addr)
{

	*channel->sender_ptr++ = addr;
	if (unlikely(channel->sender_ptr == channel->sender_ptr_end))
	{
		while (channel->state);
		channel->state = 1;
		if (channel->sender_ptr_end == channel->buf_end1)
		{
			channel->sender_ptr = channel->mapping2->buf[1];
			channel->sender_ptr_end = channel->buf_end2;
		}
		else
		{
			channel->sender_ptr = channel->buf[0];
			channel->sender_ptr_end = channel->buf_end1;
		}
	}
}

__END_DECLS

#endif
